/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
/* $Id$ */

#pragma once

#include <NotificationListener/WSPDefs.h>
#include <commontypes.h>

namespace NS_DM_Client
{
    namespace NS_NotificationListener
    {
        class WSPPushDecoder
        {
        public:
            WSPPushDecoder();

            bool    SetPDU(const void* PDU, size_t size, bool connectionless);

            /// get MIME type of Well-Known Content type
            NS_WSP::EnumContentTypes    GetWNContentType_MIMEType() const;

			/// get MIME type of Not-Known (variable length) Content type ref 
            const char*    GetNotWNContentTypeRef() const;

            bool    GetDataInfo(int& offsetFromPDUStart, int& size) const;

        private:
            WSPPushDecoder(const WSPPushDecoder&);
            WSPPushDecoder& operator = (const WSPPushDecoder&);

        protected:
			const char*    getContentTypeRef() const;

			static unsigned int     S_parseUintVar(const char* buf, int* varLen = NULL);

            static bool         S_get7bitValue(char& val);
            static int          S_parseMultipleOctetsLengthVar(const char* buf_ptr, const char*& skipLenVarPtr);

        private:
            buffer_t    m_pdu;
            bool        m_connectionless;
        };

    }

}

