/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
/* $Id$ */

#pragma once

namespace NS_DM_Client
{
	enum StatusCode
	{
		e_Ok                             = 200,
		e_AcceptForProcessing            = 202,
		e_ChunkedItemAcceptedAndBuffered = 213,
		e_OperationCancelled             = 214,
		e_NotExecuted                    = 215,
		e_AtomicRollbackOK               = 216,
		e_NotModified                    = 304,
		e_Unauthorized                   = 401,
		e_NotFound                       = 404,
		e_ForbiddenCommand               = 405,
		e_OptionalFeatureNotSupported    = 406,
		e_AuthenticationRequired         = 407,
		e_IncompleteCommand              = 412,
		e_EntityTooLarge                 = 413,
		e_UnsupportedMediaTypeOrFormat   = 415,
		e_AlreadyExists                  = 418,
		e_DeviceFull                     = 420,
		e_SizeMismatch                   = 424,
		e_PermissionDenied               = 425,
		e_CommandFailed                  = 500,
		e_Failed                         = 501,
		e_AtomicFailed                   = 507,
		e_AtomicRollBackFailed           = 516,
		e_WriteInstanceNotAlive          = 600,
		e_ReadInstanceNotAlive           = 601,
		e_Stop                           = 700
	};
}

