/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

/* $Id$ */

#pragma once

#if defined(_WIN32) || defined(WIN32) || defined(_WIN64)
#define PLATFORM_WINDOWS
#endif

#ifdef _MSC_VER

#ifndef PLATFORM_WINDOWS
#define PLATFORM_WINDOWS
#endif

#if defined(_M_IX86) || defined(_M_IX64) || defined(_M_X64)
#define PLT_LITTLE_ENDIAN
#endif

#endif  // _MSC_VER


#ifdef __GNUG__

#if defined(__linux__) || defined(__linux) || defined(linux)
#define PLATFORM_LINUX
#define PLATFORM_POSIX
#endif


#ifdef ANDROID
#define PLATFORM_ANDROID
#define PLATFORM_POSIX
#endif

#ifdef __i386__
#define PLT_LITTLE_ENDIAN
#endif

#ifdef __MACH__
#define PLATFORM_MAC
#define PLATFORM_POSIX
#endif

#endif


#ifdef PLATFORM_WINDOWS
#define PLATFORM_DEFINED
#endif

#ifdef PLATFORM_LINUX
#define PLATFORM_DEFINED
#endif

#ifdef PLATFORM_ANDROID
#define PLATFORM_DEFINED
#endif

#ifdef PLATFORM_MAC
#define PLATFORM_DEFINED
#endif


#if !defined(PLT_LITTLE_ENDIAN) && !defined(PLT_BIG_ENDIAN)
#define PLT_LITTLE_ENDIAN
#endif

#ifndef PLATFORM_DEFINED
#error Platform is undefined!
#endif
