/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

/* $Id$ */

#ifndef DATASTORAGEDEFS_H_INCLUDED
#define DATASTORAGEDEFS_H_INCLUDED

#include <sys/stat.h>
#include "commontypes.h"
#include "FileSystemUtils.h"

namespace NS_DM_Client
{

namespace NS_DataStorage
{

const char* const c_privateDataPath = "/etc/Funambol/DMClient/DataStorage";
const char* const c_streamSubPath = "/streams";

const char* const c_confFile = "conf/conf";
const char* const c_streamFileTemplate = "streams/stream_";

const char* const c_pathEmptyStr = "";

const char* const c_separatorReplacing = "%%";

const char* const c_privateDataExt = ".priv";
const char* const c_streamDataExt = ".strm";

const long c_MaxStreamNumber = 1000;

const char* const c_DataStorageLog = "DataStorage";
const char* const c_StreamHandlerLog = "StreamHandler";

char* itoa(int val, int base);
void str_replace(String& src, const String& what, const String& with);

const char c_pathSeparator = '/';
const char* const c_pathSeparatorStr = "/";

const mode_t c_fullAccessMode = S_IRWXU | S_IRWXG | S_IRWXO; // 0777
const mode_t c_fullAccessModeExceptExec = (S_IRWXU & ~ S_IXUSR) | (S_IRWXG & ~S_IXGRP) | (S_IRWXO & ~S_IXOTH); 
const mode_t c_accessMode = c_fullAccessModeExceptExec;//c_fullAccessMode;

}

}

#endif // DATASTORAGEDEFS_H_INCLUDED
